<template>
  <v-row>
    <v-col>
      <div class="mb-8 text-h1">
        {{ archived ? 'Vols archivés' : 'Vols en prévision' }}
      </div>

      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="FlightListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddFlightBtn" v-if="!archived"
          to="/vols/nouveau">
          <v-icon left>add</v-icon>
          Ajouter un vol
        </v-btn>
      </div>

      <v-data-table v-model:expanded="expanded" :headers="headers" :items="flightsPaginated.items" :loading="loading"
        :server-items-length="totalFlights" :row-props="rowHideExpandClass" class="airvam-table" item-key="id"
        show-expand hide-default-footer disable-sort loading-text="Chargement des vols ..."
        no-results-text="Aucun vol ne correspond à cette recherche"
        no-data-text="Aucun vol ne correspond à cette recherche" @click:row="goToFlight">
        <template #item.aircraft="{ item }">
          {{ item.aircraft ? item.aircraft.shortName : 'Free Seating' }}
        </template>
        <template #item.destination="{ item }">
          <div class="d-flex" ref="flightDestination">
            <div v-sanitize-html="getFlightDestination(item)">
            </div>
          </div>
        </template>
        <template #item.leg="{ item }">
          {{ item.legs.length }}
        </template>
        <!--        <template #item.modifications="{ item }">-->
        <!--          <v-chip color="error">-->
        <!--            {{ item.modifications }}-->
        <!--          </v-chip>-->
        <!--        </template>-->
        <template #item.status="{ item }">
          <v-chip :class="getStatusClass(getFlightStatus(item))" ref="flightStatusChip"
            class="text-uppercase status-chip" label>
            {{ LegStatus[getFlightStatus(item)] }}
          </v-chip>
        </template>
        <template #item.currentStatus="{ item }: { item: Flight }">
          <div v-if="item.status === 'inProgress'" class="text-uppercase d-flex align-center color-error">
            <v-icon class="mr-2">autorenew</v-icon>
            En cours
          </div>
          <div v-else-if="item.status === 'finish'" style="color: #4f4f4f;" class="text-uppercase d-flex align-center">
            <v-icon class="mr-2">history</v-icon>
            Passé
          </div>
        </template>
        <template #item.actions="{ item }">
          <v-btn icon size="x-small" class="action" data-cy="ArchiveFlightBtn" @click.stop="askArchiveFlight(item)"
            flat>
            <v-icon>move_to_inbox</v-icon>
          </v-btn>
        </template>


        <template #expanded-row="{ columns, item }">
          <td :colspan="columns.length">
            <div v-for="(leg, index) in (item.legs as Leg[])" :key="leg.id" class="px-4 py-2">
              <v-divider v-if="index > 0"></v-divider>
              <div class="d-flex align-center">
                <v-avatar size="32" class="mr-4 outlined">
                  {{ index + 1 }}
                </v-avatar>
                <div style="width: 120px;">
                  {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
                </div>
                <div :style="'width: ' + destinationWidth + '; margin-left: ' + destinationMargin + ';'"
                   v-sanitize-html="getLegDestination(leg)"></div>
                <v-chip :style="'margin-left: ' + statusChipMargin" label :class="getStatusClass(leg.status)"
                  class="text-uppercase status-chip">
                  {{ legStatus[leg.status] }}
                </v-chip>
              </div>
            </div>
          </td>
        </template>
      </v-data-table>

      <div class="pt-2 mb-4" v-if="flightsPaginated?.meta">
        <v-pagination v-model="currentPage" :total-visible="7" :length="flightsPaginated.meta.totalPages" rounded="circle" density="comfortable">
        </v-pagination>
      </div>
    </v-col>

    <LazyConfirmDialog v-if="flightDialog" v-model="flightDialog" :dialogText="flightDialogText"
      :dialogTitle="flightDialogTitle" @confirm="archiveFlight" @close="close" />
  </v-row>
</template>

<script setup lang="ts">

import { dateToStringTime, debounce, getStatusClass } from "../mixins/utilsMixin";
import { LegStatus } from "~/dto/legstatus.enum";
import { Flight } from "~/dto/flight.dto";
import { Leg } from "~/dto/leg.dto";

const props = defineProps<{ archived: boolean }>();

const legStatus = LegStatus

const flightDialog = ref(false);
const flightDialogText = ref('');
const flightToArchive: Ref<Flight | null> = ref(null);
const loading = ref(true);
const expanded = ref([]);
const totalFlights = ref(0);
const currentPage = ref(0);
const flightStatusChip: Ref<any> = ref(null);
const flightDestination: Ref<any> = ref(null);
const destinationWidth = ref('100px');
const destinationMargin = ref('100px');
const statusChipMargin = ref('100px');
const query = ref('');

const store = useStore();
const { flightsPaginated } = storeToRefs(useStore());

const { $api, $toast } = useNuxtApp();

const goToFlight = (_event: Event, { item: flight }: { item: Flight }): void => {
  navigateTo({ path: `/vols/${flight.id}` });
}

const getFlightDestination = (flight: Flight): string => {
  return getLegDestination(flight.legs[0], flight.legs[flight.legs.length - 1]);
}

const getLegDestination = (leg: Leg, legArrival: Leg | null = null): string => {
  if (!leg) {
    return '';
  }
  const date = <Date>leg?.departureTime;
  return `${leg?.departure.oaci} - ${!legArrival ? leg.arrival.oaci : legArrival.arrival.oaci} <br/>
${date.toLocaleDateString()} UTC ${dateToStringTime(date)}`;
}

const getFlightStatus = (flight: Flight): keyof typeof LegStatus => {
  if (flight.legs.findIndex(l => l.status === 'to_schedule') >= 0) {
    return 'to_schedule';
  } else if (flight.legs.findIndex(l => l.status === 'incomplete') >= 0) {
    return 'incomplete';
  } else if (flight.legs.findIndex(l => l.status === 'lmc') >= 0) {
    return 'lmc';
  } else if (flight.legs.findIndex(l => l.status === 'scheduled') >= 0) {
    return 'scheduled';
  } else if (flight.legs.findIndex(l => l.status === 'finalized') >= 0) {
    return 'finalized';
  }
  // @ts-ignore
  return '';
}

const askArchiveFlight = (flight: Flight) => {
  flightDialogText.value = `Êtes-vous sûr de vouloir ${props.archived ? 'désarchiver' : 'archiver'} le vol n°${flight.cotamNumber} ${flight.legs[0].departure.oaci} > ${flight.legs[flight.legs.length - 1].arrival.oaci} ?`;
  flightToArchive.value = flight;
  flightDialog.value = true;
}

const archiveFlight = async () => {
  try {
    props.archived ? await $api.flightPaginated.activate(flightToArchive.value?.id) : await $api.flightPaginated.delete(flightToArchive.value?.id);
    await loadFlights(1);
    $toast.success(`Vol ${props.archived ? 'désarchivé' : 'archivé'}`);
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(`Erreur lors ${props.archived ? 'du désarchivage' : 'de l\'archivage'} du vol`);
  }
  close();
}

const rowHideExpandClass = ({ item }: { item: Flight }) => {
  if (item.legs && item.legs.length > 1)
    return undefined
  return { class: 'hide-expand' };
}

const close = () => {
  flightToArchive.value = null;
  flightDialog.value = false;
}

const loadFlights = async (page: number, query: string = '') => {
  loading.value = true;
  store.setFlightsPaginated(await $api.flightPaginated.list(query, page, { archived: props.archived }));
  totalFlights.value = flightsPaginated.value.items.length;
  currentPage.value = flightsPaginated.value?.meta.currentPage;
  loading.value = false;
  computeMargins();
}

const computeMargins = () => {
  setTimeout(() => {
    if (!flightStatusChip.value || !flightDestination.value) {
      return;
    }
    const left = flightDestination.value.parentElement.offsetLeft + 16;
    const width = flightDestination.value.offsetWidth;
    const leftBis = flightStatusChip.value.$el.offsetLeft;
    destinationMargin.value = `${left - 32 - 16 - 120 - 16}px`;
    destinationWidth.value = `${width}px`;
    statusChipMargin.value = `${leftBis - left - width}px`;
  }, 100);
}

loadFlights(flightsPaginated.value?.meta.currentPage);
window.addEventListener('resize', computeMargins);
onUnmounted(() => {
  window.removeEventListener('resize', computeMargins);
});

watch(query, debounce(function () {
  loadFlights(1, query.value);
}, 300));

watch(currentPage, () => {
  if (currentPage.value === flightsPaginated.value.meta.currentPage) {
    return;
  }
  loadFlights(currentPage.value, query.value);
});

const headers = [
  { title: 'N° Mission', key: 'missionNumber', },
  { title: 'N° COTAM', key: 'cotamNumber' },
  { title: 'Nom mission', key: 'missionName' },
  { title: 'Type Avion', key: 'aircraft' },
  { title: 'Destination', key: 'destination' },
  { title: 'Leg', key: 'leg' },
  // {title: 'Modif', key: 'modifications'},
  { title: 'Dossier avion', key: 'status' },
  { title: 'Statut de vol', key: 'currentStatus' },
  { title: '', key: 'actions', sortable: false },
];
const flightDialogTitle = props.archived ? `Désarchiver un vol` : `Archiver un vol`;
</script>

<style lang="scss">
.v-data-table.airvam-table tbody tr:not(.v-data-table__expanded__content) {
  cursor: pointer;
}
</style>
